"""
Grader for Homework 3
"""
import sys
import time
import hw3_objectives
from numpy import dot
from math import sqrt

def TestDescent(objfn, method, method_name):
  hw3_objectives.ResetCounts()
  x_init = [-1.2, 1]

  params = {
      'GradientDescent': {'maxit':5000,'tol':1e-4},
      'NewtonMethod':    {'maxit':100,'tol':1e-9}
  }

  # run the objective
  start = time.time()
  inform, x_opt = method(objfn, x_init, params[method_name])
  dt = time.time() - start
  
  func_count = hw3_objectives.__COUNTS[hw3_objectives.GET_FUNC]
  grad_count = hw3_objectives.__COUNTS[hw3_objectives.GET_GRAD]
  hess_count = hw3_objectives.__COUNTS[hw3_objectives.GET_HESS]

  # TOOD determine score
  return {'time': dt, 'x_opt':x_opt, 'converged':inform['status'],
          'iters':inform['iter'], 'func_calls':func_count,
          'grad_calls':grad_count,'hess_calls':hess_count}

def TestStudentFile(filename):
  print filename
  stumod = __import__(filename)

  methods = [
      ('GradientDescent', stumod.GradientDescent),
      ('NewtonMethod', stumod.NewtonMethod)
  ]
  objs = [hw3_objectives.obja,hw3_objectives.objb,
          hw3_objectives.objc,hw3_objectives.objd]
          
  for objfn in objs:
    for method in methods:
      funoutput = TestDescent(objfn, method[1],method[0])
      print method[0]
      print "----------------"
      print objfn.func_name
      if funoutput['converged'] == 0:
        print 'CONVERGENCE FAILURE:'
        print '%d steps were taken without' % funoutput['iters']
        print 'gradient size decreasing below tolerance.\n'
      else:
        print 'Success: %d steps taken\n' % funoutput['iters']
        print "  function calls: ", funoutput['func_calls']
        print "  gradient calls: ", funoutput['grad_calls']
        print "  hessian calls: ",  funoutput['hess_calls']
        print "Ending Point:"
        print funoutput['x_opt']
        print "Ending Value = %d" % objfn(funoutput['x_opt'],'func')
        print "Ending gradient:"
        g_out = objfn(funoutput['x_opt'],'grad');
        print g_out
        print "Norm of ending gradient: ", sqrt(dot(g_out,g_out))
        print "\n\n"
        
def main():
  if len(sys.argv) != 2:
    print "usage: autograde PATH_TO_FILE (without extension)"
    return

  TestStudentFile(sys.argv[1])

if __name__ == "__main__":
  main()
